/* WeirdX - Guess.
 *
 * Copyright (C) 1999,2000 JCraft, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package com.jcraft.weirdx;
import java.io.*;
import java.awt.event.KeyEvent;

final class Keymap_dk extends Keymap{
  private int[] _map={
    0xffe3, 0x0000,  // 8 (Control_L)
    0xffe4, 0x0000,  // 9 (Control_R)
    0xffe1, 0x0000,  // 10 (Shift_L)
    0xffe2, 0x0000,  // 11 (Shift_R)
    0xffe7, 0x0000,  // 12 (Meta_L)
    0xffe8, 0x0000,  // 13 (Meta_R)
    0xffe9, 0x0000,  // 14 (Alt_L)
    0xffea, 0x0000,  // 15 (Alt_R)
    0x0020, 0x0000,  // 16 (space)
    0x0030, 0x0029,  // 17 (0) (parenright)
    0x0031, 0x0021,  // 18 (1) (exclam)
    0x0032, 0x0040,  // 19 (2) (at)
    0x0033, 0x0023,  // 20 (3) (numbersign)
    0x0034, 0x0024,  // 21 (4) (dollar)
    0x0035, 0x0025,  // 22 (5) (percent)
    0x0036, 0x005e,  // 23 (6) (asciicircum)
    0x0037, 0x0026,  // 24 (7) (ampersand)
    0x0038, 0x002a,  // 25 (8) (asterisk)
    0x0039, 0x0028,  // 26 (9) (parenleft)
    0x002d, 0x005f,  // 27 (minus) (underscore)
    0x003d, 0x002b,  // 28 (equal) (plus)
    0x005b, 0x007b,  // 29 (bracketleft) (braceleft)
    0x005d, 0x007d,  // 30 (bracketright) (braceright)
    0x003b, 0x003a,  // 31 (semicolon) (colon)
    0x0027, 0x0022,  // 32 (apostrophe) (quotedbl)
    0x0060, 0x007e,  // 33 (grave) (asciitilde)
    0x002c, 0x003c,  // 34 (comma) (less)
    0x002e, 0x003e,  // 35 (period) (greater)
    0x002f, 0x003f,  // 36 (slash) (question)
    0x005c, 0x007c,  // 37 (backslash) (bar)
    0x0061, 0x0041,  // 38 (a) (A)
    0x0062, 0x0042,  // 39 (b) (B)
    0x0063, 0x0043,  // 40 (c) (C)
    0x0064, 0x0044,  // 41 (d) (D)
    0x0065, 0x0045,  // 42 (e) (E)
    0x0066, 0x0046,  // 43 (f) (F)
    0x0067, 0x0047,  // 44 (g) (G)
    0x0068, 0x0048,  // 45 (h) (H)
    0x0069, 0x0049,  // 46 (i) (I)
    0x006a, 0x004a,  // 47 (j) (J)
    0x006b, 0x004b,  // 48 (k) (K)
    0x006c, 0x004c,  // 49 (l) (L)
    0x006d, 0x004d,  // 50 (m) (M)
    0x006e, 0x004e,  // 51 (n) (N)
    0x006f, 0x004f,  // 52 (o) (O)
    0x0070, 0x0050,  // 53 (p) (P)
    0x0071, 0x0051,  // 54 (q) (Q)
    0x0072, 0x0052,  // 55 (r) (R)
    0x0073, 0x0053,  // 56 (s) (S)
    0x0074, 0x0054,  // 57 (t) (T)
    0x0075, 0x0055,  // 58 (u) (U)
    0x0076, 0x0056,  // 59 (v) (V)
    0x0077, 0x0057,  // 60 (w) (W)
    0x0078, 0x0058,  // 61 (x) (X)
    0x0079, 0x0059,  // 62 (y) (Y)
    0x007a, 0x005a,  // 63 (z) (Z)
    0xff08, 0x0000,  // 64 (BackSpace)
    0xff0d, 0x0000,  // 65 (Return)
    0xff09, 0x0000,  // 66 (Tab)
    0xff1b, 0x0000,  // 67 (Escape)
    0xffff, 0x0000,  // 68 (Delete)
    0xff50, 0x0000,  // 69 (Home)
    0xff57, 0x0000,  // 70 (End)
    0xff55, 0x0000,  // 71 (Prior)
    0xff56, 0x0000,  // 72 (Next)
    0xff52, 0x0000,  // 73 (Up)
    0xff54, 0x0000,  // 74 (Down)
    0xff51, 0x0000,  // 75 (Left)
    0xff53, 0x0000,  // 76 (Right)
    0xffbe, 0x0000,  // 77 (F1)
    0xffbf, 0x0000,  // 78 (F2)
    0xffc0, 0x0000,  // 79 (F3)
    0xffc1, 0x0000,  // 80 (F4)
    0xffc2, 0x0000,  // 81 (F5)
    0xffc3, 0x0000,  // 82 (F6)
    0xffc4, 0x0000,  // 83 (F7)
    0xffc5, 0x0000,  // 84 (F8)
    0xffc6, 0x0000,  // 85 (F9)
    0xffc7, 0x0000,  // 86 (F10)
    0xffc8, 0x0000,  // 87 (F11)
    0xffc9, 0x0000,  // 88 (F12)
    0xff63, 0x0000,  // 89 (Insert)
    0x0000, 0x0000,  // 90
    0x0000, 0x0000,  // 91
    0x0000, 0x0000,  // 92
    0x0000, 0x0000,  // 93
    0x0000, 0x0000,  // 94
    0x0000, 0x0000,  // 95
    0x0000, 0x0000,  // 96
    0x0000, 0x0000,  // 97
    0x0000, 0x0000,  // 98
    0x0000, 0x0000,  // 99
    0x0000, 0x0000,  // 100
    0x0000, 0x0000,  // 101
    0x0000, 0x0000,  // 102
    0x0000, 0x0000,  // 103
    0x0000, 0x0000,  // 104
    0x0000, 0x0000,  // 105
    0x0000, 0x0000,  // 106
    0x0000, 0x0000,  // 107
    0x0000, 0x0000,  // 108
    0x0000, 0x0000,  // 109
    0x0000, 0x0000,  // 110
    0x0000, 0x0000,  // 111
    0x0000, 0x0000,  // 112
    0x0000, 0x0000,  // 113
    0x0000, 0x0000,  // 114
    0x0000, 0x0000,  // 115
    0x0000, 0x0000,  // 116
    0x0000, 0x0000,  // 117
    0x0000, 0x0000,  // 118
    0x0000, 0x0000,  // 119
    0x0000, 0x0000,  // 120
    0x0000, 0x0000,  // 121
    0x0000, 0x0000,  // 122
    0x0000, 0x0000,  // 123
    0x0000, 0x0000,  // 124
    0x0000, 0x0000,  // 125
    0x0000, 0x0000,  // 126
    0x0000, 0x0000,  // 127
    0x0000, 0x0000,  // 128
    0x0000, 0x0000,  // 129
    0x0000, 0x0000,  // 130
    0x0000, 0x0000,  // 131
    0x0000, 0x0000,  // 132
    0x0000, 0x0000,  // 133
    0x0000, 0x0000,  // 134
    0x0000, 0x0000,  // 135
    0x0000, 0x0000,  // 136
    0x0000, 0x0000,  // 137
    0x0000, 0x0000,  // 138
    0x0000, 0x0000,  // 139
    0x0000, 0x0000,  // 140
    0x0000, 0x0000,  // 141
    0x0000, 0x0000,  // 142
    0x0000, 0x0000,  // 143
    0x0000, 0x0000,  // 144
    0x0000, 0x0000,  // 145
    0x0000, 0x0000,  // 146
    0x0000, 0x0000,  // 147
    0x0000, 0x0000,  // 148
    0x0000, 0x0000,  // 149
    0x0000, 0x0000,  // 150
    0x0000, 0x0000,  // 151
    0x0000, 0x0000,  // 152
    0x0000, 0x0000,  // 153
    0x0000, 0x0000,  // 154
    0x0000, 0x0000,  // 155
    0x0000, 0x0000,  // 156
    0x0000, 0x0000,  // 157
    0x0000, 0x0000,  // 158
    0x0000, 0x0000,  // 159
    0x0000, 0x0000,  // 160
    0x0000, 0x0000,  // 161
    0x0000, 0x0000,  // 162
    0x0000, 0x0000,  // 163
    0x0000, 0x0000,  // 164
    0x0000, 0x0000,  // 165
    0x0000, 0x0000,  // 166
    0x0000, 0x0000,  // 167
    0x0000, 0x0000,  // 168
    0x0000, 0x0000,  // 169
    0x0000, 0x0000,  // 170
    0x0000, 0x0000,  // 171
    0x0000, 0x0000,  // 172
    0x0000, 0x0000,  // 173
    0x0000, 0x0000,  // 174
    0x0000, 0x0000,  // 175
    0x0000, 0x0000,  // 176
    0x0000, 0x0000,  // 177
    0x0000, 0x0000,  // 178
    0x0000, 0x0000,  // 179
    0x0000, 0x0000,  // 180
    0x0000, 0x0000,  // 181
    0x0000, 0x0000,  // 182
    0x0000, 0x0000,  // 183
    0x0000, 0x0000,  // 184
    0x0000, 0x0000,  // 185
    0x0000, 0x0000,  // 186
    0x0000, 0x0000,  // 187
    0x0000, 0x0000,  // 188
    0x0000, 0x0000,  // 189
    0x0000, 0x0000,  // 190
    0x0000, 0x0000,  // 191
    0x0000, 0x0000,  // 192
    0x0000, 0x0000,  // 193
    0x0000, 0x0000,  // 194
    0x0000, 0x0000,  // 195
    0x0000, 0x0000,  // 196
    0x0000, 0x0000,  // 197
    0x0000, 0x0000,  // 198
    0x0000, 0x0000,  // 199
    0x0000, 0x0000,  // 200
    0x0000, 0x0000,  // 201
    0x0000, 0x0000,  // 202
    0x0000, 0x0000,  // 203
    0x0000, 0x0000,  // 204
    0x0000, 0x0000,  // 205
    0x0000, 0x0000,  // 206
    0x0000, 0x0000,  // 207
    0x0000, 0x0000,  // 208
    0x0000, 0x0000,  // 209
    0x0000, 0x0000,  // 210
    0x0000, 0x0000,  // 211
    0x0000, 0x0000,  // 212
    0x0000, 0x0000,  // 213
    0x0000, 0x0000,  // 214
    0x0000, 0x0000,  // 215
    0x0000, 0x0000,  // 216
    0x0000, 0x0000,  // 217
    0x0000, 0x0000,  // 218
    0x0000, 0x0000,  // 219
    0x0000, 0x0000,  // 220
    0x0000, 0x0000,  // 221
    0x0000, 0x0000,  // 222
    0x0000, 0x0000,  // 223
    0x0000, 0x0000,  // 224
    0x0000, 0x0000,  // 225
    0x0000, 0x0000,  // 226
    0x0000, 0x0000,  // 227
    0x0000, 0x0000,  // 228
    0x0000, 0x0000,  // 229
    0x0000, 0x0000,  // 230
    0x0000, 0x0000,  // 231
    0x0000, 0x0000,  // 232
    0x0000, 0x0000,  // 233
    0x0000, 0x0000,  // 234
    0x0000, 0x0000,  // 235
    0x0000, 0x0000,  // 236
    0x0000, 0x0000,  // 237
    0x0000, 0x0000,  // 238
    0x0000, 0x0000,  // 239
    0x0000, 0x0000,  // 240
    0x0000, 0x0000,  // 241
    0x0000, 0x0000,  // 242
    0x0000, 0x0000,  // 243
    0x0000, 0x0000,  // 244
    0x0000, 0x0000,  // 245
    0x0000, 0x0000,  // 246
    0x0000, 0x0000,  // 247
    0x0000, 0x0000,  // 248
    0x0000, 0x0000,  // 249
    0x0000, 0x0000,  // 250
    0x0000, 0x0000,  // 251
    0x0000, 0x0000,  // 252
    0x0000, 0x0000,  // 253
    0x0000, 0x0000,  // 254
    0x0000, 0x0000   // 255
  };

  Keymap_dk(){
    start=8;
    width=2;
    count=255-8+1;
    map=_map;
  }
  final public int getCode(KeyEvent e){
    if(e.isShiftDown()) state|=1;
    if(e.isControlDown()) state|=4;
    if(e.isAltDown()) state|=8;
    int key=e.getKeyCode();
    if(key!=0){
      switch(key){
      case KeyEvent.VK_A:
      case KeyEvent.VK_B:
      case KeyEvent.VK_C:
      case KeyEvent.VK_D:
      case KeyEvent.VK_E:
      case KeyEvent.VK_F:
      case KeyEvent.VK_G:
      case KeyEvent.VK_H:
      case KeyEvent.VK_I:
      case KeyEvent.VK_J:
      case KeyEvent.VK_K:
      case KeyEvent.VK_L:
      case KeyEvent.VK_M:
      case KeyEvent.VK_N:
      case KeyEvent.VK_O:
      case KeyEvent.VK_P:
      case KeyEvent.VK_Q:
      case KeyEvent.VK_R:
      case KeyEvent.VK_S:
      case KeyEvent.VK_T:
      case KeyEvent.VK_U:
      case KeyEvent.VK_V:
      case KeyEvent.VK_W:
      case KeyEvent.VK_X:
      case KeyEvent.VK_Y:
      case KeyEvent.VK_Z:
	key=key+0x20;
	break;
      case KeyEvent.VK_0:
      case KeyEvent.VK_1:
      case KeyEvent.VK_2:
      case KeyEvent.VK_3:
      case KeyEvent.VK_4:
      case KeyEvent.VK_5:
      case KeyEvent.VK_6:
      case KeyEvent.VK_7:
      case KeyEvent.VK_8:
      case KeyEvent.VK_9:
       break;
      case KeyEvent.VK_ENTER:
	key=0xff0d; break;
      case KeyEvent.VK_BACK_SPACE:
	key=0xff08; break;
      case KeyEvent.VK_TAB:
	key=0xff09; break;
      case KeyEvent.VK_COMMA:
      case KeyEvent.VK_PERIOD:
      case KeyEvent.VK_SLASH:
      case KeyEvent.VK_SEMICOLON:
      case KeyEvent.VK_EQUALS:
      case KeyEvent.VK_OPEN_BRACKET:
      case KeyEvent.VK_BACK_SLASH:
      case KeyEvent.VK_CLOSE_BRACKET:
      case KeyEvent.VK_SPACE:
	break;
      case KeyEvent.VK_BACK_QUOTE:
	key=0x60; break;
      case KeyEvent.VK_QUOTE:
	key=0x27; break;
      case KeyEvent.VK_SHIFT:
	key=0xffe1; break;
      case KeyEvent.VK_CONTROL:
	key=0xffe3; break;
      case KeyEvent.VK_ALT:
	key=0xffe9; break;
      case KeyEvent.VK_PAUSE:
	key=0xff13; break;
      case KeyEvent.VK_CAPS_LOCK:
	key=0xffe5; break;
      case KeyEvent.VK_ESCAPE:
	key=0xff1b; break;
      case KeyEvent.VK_PAGE_UP:
	key=0xff55; break;
      case KeyEvent.VK_PAGE_DOWN:
	key=0xff56; break;
      case KeyEvent.VK_END:
	key=0xff57; break;
      case KeyEvent.VK_HOME:
	key=0xff50; break;
      case KeyEvent.VK_LEFT:
	key=0xff51; break;
      case KeyEvent.VK_UP:
	key=0xff52; break;
      case KeyEvent.VK_RIGHT:
	key=0xff53; break;
      case KeyEvent.VK_DOWN:
	key=0xff54; break;
      case KeyEvent.VK_NUMPAD0:
	key=0xffb0; break;
      case KeyEvent.VK_NUMPAD1:
	key=0xffb1; break;
      case KeyEvent.VK_NUMPAD2:
	key=0xffb2; break;
      case KeyEvent.VK_NUMPAD3:
	key=0xffb3; break;
      case KeyEvent.VK_NUMPAD4:
	key=0xffb4; break;
      case KeyEvent.VK_NUMPAD5:
	key=0xffb5; break;
      case KeyEvent.VK_NUMPAD6:
	key=0xffb6; break;
      case KeyEvent.VK_NUMPAD7:
	key=0xffb7; break;
      case KeyEvent.VK_NUMPAD8:
	key=0xffb8; break;
      case KeyEvent.VK_NUMPAD9:
	key=0xffb9; break;
      case KeyEvent.VK_MULTIPLY:
	key=0xffaa; break;
      case KeyEvent.VK_ADD:
	key=0xffab; break;
      case KeyEvent.VK_SEPARATER:
	key=0xffac; break;
      case KeyEvent.VK_SUBTRACT:
	key=0xffad; break;
      case KeyEvent.VK_DECIMAL:
	key=0xffae; break;
      case KeyEvent.VK_DIVIDE:
	key=0xffaf; break;
      case KeyEvent.VK_F1:
	key=0xffbe; break;
      case KeyEvent.VK_F2:
	key=0xffbf; break;
      case KeyEvent.VK_F3:
	key=0xffc0; break;
      case KeyEvent.VK_F4:
	key=0xffc1; break;
      case KeyEvent.VK_F5:
	key=0xffc2; break;
      case KeyEvent.VK_F6:
	key=0xffc3; break;
      case KeyEvent.VK_F7:
	key=0xffc4; break;
      case KeyEvent.VK_F8:
	key=0xffc5; break;
      case KeyEvent.VK_F9:
	key=0xffc6; break;
      case KeyEvent.VK_F10:
	key=0xffc7; break;
      case KeyEvent.VK_F11:
	key=0xffc8; break;
      case KeyEvent.VK_F12:
	key=0xffc9; break;
      case KeyEvent.VK_DELETE:
	key=0xffff; break;
      case KeyEvent.VK_NUM_LOCK:
	key=0xff7f; break;
      case KeyEvent.VK_SCROLL_LOCK:
	key=0xff14; break;
      case KeyEvent.VK_PRINTSCREEN:
	key=0xff61; break;
      case KeyEvent.VK_INSERT:
	key=0xff63; break;
      case KeyEvent.VK_HELP:
	key=0xff6a; break;
      case KeyEvent.VK_META:
	key=0xffe7; break;

/*    
      // For European keyboards 
      case KeyEvent.VK_DEAD_GRAVE:
      case KeyEvent.VK_DEAD_ACUTE:
      case KeyEvent.VK_DEAD_CIRCUMFLEX:
      case KeyEvent.VK_DEAD_TILDE:
      case KeyEvent.VK_DEAD_MACRON:
      case KeyEvent.VK_DEAD_BREVE:
      case KeyEvent.VK_DEAD_ABOVEDOT:
      case KeyEvent.VK_DEAD_DIAERESIS:
      case KeyEvent.VK_DEAD_ABOVERING:
      case KeyEvent.VK_DEAD_DOUBLEACUTE:
      case KeyEvent.VK_DEAD_CARON:
      case KeyEvent.VK_DEAD_CEDILLA:
      case KeyEvent.VK_DEAD_OGONEK:
      case KeyEvent.VK_DEAD_IOTA:
      case KeyEvent.VK_DEAD_VOICED_SOUND:
      case KeyEvent.VK_DEAD_SEMIVOICED_SOUND:

      case KeyEvent.VK_AMPERSAND:
      case KeyEvent.VK_ASTERISK:
      case KeyEvent.VK_QUOTEDBL:
      case KeyEvent.VK_LESS:

      case KeyEvent.VK_GREATER:
      case KeyEvent.VK_BRACELEFT:
      case KeyEvent.VK_BRACERIGHT:

      // for Asian Keyboards
      case KeyEvent.VK_FINAL:
      case KeyEvent.VK_CONVERT:
      case KeyEvent.VK_NONCONVERT:
      case KeyEvent.VK_ACCEPT:
      case KeyEvent.VK_MODECHANGE:
      case KeyEvent.VK_KANA:
      case KeyEvent.VK_KANJI:

      // for Sun keyboards
      case KeyEvent.VK_CUT:
      case KeyEvent.VK_COPY:
      case KeyEvent.VK_PASTE:
      case KeyEvent.VK_UNDO:
      case KeyEvent.VK_AGAIN:
      case KeyEvent.VK_FIND:
      case KeyEvent.VK_PROPS:
      case KeyEvent.VK_STOP:
*/
      default:
	key=e.getKeyChar();
      }
    }
    else{
      key=e.getKeyChar();
    }
    int s=0;
    if(km!=null){
      int i=0;
      int j=0;
      s=km.start;
      while(i<km.count*km.width){
	if(km.map[i]==key)break;
	i++;
	j++;
	if(j==km.width){
	  j=0;
	  s++;
	}
      }
    }
    return s;
  }
}
